Package: riboSeqR
Type: Package
Title: Analysis of sequencing data from ribosome profiling experiments
Description: Plotting functions, frameshift detection and parsing of sequencing
    data from ribosome profiling experiments.
Version: 1.45.0
Date: 2025-07-23
Authors@R: c(person("Thomas J.", "Hardcastle", role = "aut"),
  person("Samuel", "Granjeaud", role = "cre", email = "samuel.granjeaud@inserm.fr", comment=c(ORCID="0000-0001-9245-1535")))
License: GPL-3
LazyLoad: yes
Depends: R (>= 3.0.2), methods, GenomicRanges, abind
Imports: Rsamtools, IRanges, S4Vectors, baySeq, Seqinfo, seqLogo
Suggests: BiocStyle, RUnit, BiocGenerics
biocViews: Sequencing,Genetics,Visualization,RiboSeq
URL: https://github.com/samgg/riboSeqR
BugReports: https://github.com/samgg/riboSeqR/issues
git_url: https://git.bioconductor.org/packages/riboSeqR
git_branch: devel
git_last_commit: 77f80b5
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-10-31 23:47:35 UTC; biocbuild
Author: Thomas J. Hardcastle [aut],
  Samuel Granjeaud [cre] (ORCID: <https://orcid.org/0000-0001-9245-1535>)
Maintainer: Samuel Granjeaud <samuel.granjeaud@inserm.fr>

libScales <- function(rC, riboDat, lengths, frames, method = "edgeR") {
    riboC <- sliceCounts(rC, lengths = lengths, frames = frames)
    if(length(riboDat@rnaGR) > 0) {
        rnaC <- rnaCounts(riboDat, rC@CDS)
        rnaLS = getLibsizes(data = rnaC, replicates = riboDat@replicates, estimationType = "edgeR")
    } else rnaLS <- NULL
    riboLS = getLibsizes(data = riboC, replicates = riboDat@replicates, estimationType = "edgeR")    
    list(riboLS = riboLS, rnaLS = rnaLS)
}

setMethod("show", "riboCoding", function(object) {
  show(object@CDS)

  cat('\nSlot "replicates"\n')
  print(object@replicates)
  
  cat('\nHits array; dimension ', dim(object@hits), '\n')
  cat('\nUnique hits array; dimension ', dim(object@unqHits), '\n')  
})

setMethod("[", signature(x = "riboCoding", i = "ANY", j = "ANY"), function(x, i, j, ..., drop = FALSE) {
#  x <- callNextMethod(x, i, j, ..., drop = FALSE)
  if(!missing(i))
    {
      i <- as.vector(i)
      if(is.logical(i)) i <- which(i)
      x@CDS <- x@CDS[i]      
    }  
  if(!missing(j))
    {
      j <- as.vector(j)
      if(is.logical(j)) j <- which(j)
      x@replicates <- x@replicates[j]
    }
  if(missing(i)) i <- NULL
  if(missing(j)) j <- NULL
  
  x@hits <- .sliceArray(list(i, j), x@hits)
  x@unqHits <- .sliceArray(list(i, j), x@unqHits)
  x
})

.tableOverlaps <-
function(grf, gral, uniqueHits = FALSE, lengthRange = 25:30) {
  #gral.f <- gral[gral$frame == frame]
  gral <- gral[width(gral) %in% lengthRange]
  spl27.f <- split(start(gral), factor(as.character(seqnames(gral)), levels = seqlevels(grf)))
  spl27.frame <- split(gral$frame, factor(as.character(seqnames(gral)), levels = seqlevels(grf)))
  spl27.length <- split(width(gral), factor(as.character(seqnames(gral)), levels = seqlevels(grf)))
  
  splfr0 <- split(start(grf), factor(as.character(seqnames(grf)), levels = (seqlevels(grf))))
  splfr0e <- split(end(grf), factor(as.character(seqnames(grf)), levels = (seqlevels(grf))))  
  tov <- lapply(1:length(spl27.f), function(ii) {
    if(length(splfr0[[ii]]) > 0) {      
      z <- data.frame(startCDS = findInterval(spl27.f[[ii]], splfr0[[ii]]), endCDS = findInterval(spl27.f[[ii]], splfr0e[[ii]]), start = spl27.f[[ii]], frame = spl27.frame[[ii]], length = spl27.length[[ii]])
      z <- z[z[,1] != 0 & z[,1] == z[,2] + 1,]
      lfTab <- as.data.frame(
                 table(factor(z[,1], levels = 1:length(splfr0[[ii]])), factor(z$frame, levels = 0:2), factor(z$length, levels = lengthRange))
                 )
      lfValues <- matrix(lfTab[,4], nrow = length(splfr0[[ii]]))
      colnames(lfValues) <- paste(lfTab[,2], lfTab[,3], sep = ":")[lfTab[,1] == 1]      
      
      zunq <- z[!duplicated(z[,c("start", "length")]),]
      lfTabUnq <- as.data.frame(table(factor(zunq[,1], levels = 1:length(splfr0[[ii]])), factor(zunq$frame, levels = 0:2), factor(zunq$length, levels = lengthRange)))
      lfValuesUnq <- matrix(lfTabUnq[,4], nrow = length(splfr0[[ii]]))
      colnames(lfValuesUnq) <- paste(lfTabUnq[,2], lfTabUnq[,3], sep = ":")[lfTabUnq[,1] == 1]      
      
#      }
      list(lfValues = lfValues, lfValuesUnq = lfValuesUnq)
    } else NULL
  })

  hits <- do.call("rbind", (lapply(tov, function(x) x$lfValues)))
  hits <- array(hits, dim = c(nrow(hits), 1, 3, length(lengthRange)), dimnames = list(NULL, NULL, 0:2, lengthRange))
  
  unqHits <- do.call("rbind", (lapply(tov, function(x) x$lfValuesUnq)))
  unqHits <- array(hits, dim = c(nrow(hits), 1, 3, length(lengthRange)), dimnames = list(NULL, NULL, 0:2, lengthRange))
  message(".", appendLF = FALSE)  

  new("riboCoding", CDS = grf, hits = hits, unqHits = unqHits)
}

findCDS <-
function(fastaFile, startCodon = c("ATG"), stopCodon = c("TAG", "TAA", "TGA"))
  {
    fasta <- scan(fastaFile, sep = "\n", what = "character")
    fastaHeads <- gsub(">", "", fasta[grep(">", fasta)])
    headloc <- grep(">", fasta)
    fastaSeq <- sapply(1:length(headloc), function(ii) toupper(paste(fasta[(headloc[ii] + 1):c(headloc[-1] - 1, length(fasta))[ii]], collapse = "")))
    
    codpos <- paste("(", paste(startCodon, collapse = " |"), " )(.{3} )*?(", paste(stopCodon, collapse = "|"), "|.{0,2}$)", sep = "")
    frame0 <- gregexpr(codpos, gsub("(.{3})", "\\1 ", fastaSeq))
    frame1 <- gregexpr(codpos, gsub("(.{3})", "\\1 ", substr(fastaSeq, 2, nchar(fastaSeq))))
    frame2 <- gregexpr(codpos, gsub("(.{3})", "\\1 ", substr(fastaSeq, 3, nchar(fastaSeq))))
    
    fr0mat <- lapply(frame0, function(x) if(x[1] != -1) cbind((as.integer(x) + 3) / 4 * 3 -2, (attr(x, "match.length") + 1) / 4 * 3) else matrix(NA, ncol = 2, nrow = 0))
    fr0GR <- GRanges(seqnames = factor(rep(fastaHeads, sapply(fr0mat, nrow)), levels = fastaHeads),
                     IRanges(start = do.call("rbind", fr0mat)[,1], width = do.call("rbind", fr0mat)[,2]),
                     frame = rep(0, sum(sapply(fr0mat, nrow))))
    fr1mat <- lapply(frame1, function(x) if(x[1] != -1) cbind((as.integer(x) + 3) / 4 * 3 - 1, (attr(x, "match.length") + 1) / 4 * 3) else matrix(NA, ncol = 2, nrow = 0))
    fr1GR <- GRanges(seqnames = factor(rep(fastaHeads, sapply(fr1mat, nrow)), levels = fastaHeads),
                     IRanges(start = do.call("rbind", fr1mat)[,1], width = do.call("rbind", fr1mat)[,2]),
                     frame = rep(1, sum(sapply(fr1mat, nrow))))
    fr2mat <- lapply(frame2, function(x) if(x[1] != -1) cbind((as.integer(x) + 3) / 4 * 3, (attr(x, "match.length") + 1) / 4 * 3) else matrix(NA, ncol = 2, nrow = 0))
    fr2GR <- GRanges(seqnames = factor(rep(fastaHeads, sapply(fr2mat, nrow)), levels = fastaHeads),
                     IRanges(start = do.call("rbind", fr2mat)[,1], width = do.call("rbind", fr2mat)[,2]),
                     frame = rep(2, sum(sapply(fr2mat, nrow))))

    gr <- c(fr0GR, fr1GR, fr2GR)
    gr <- gr[order(as.integer(seqnames(gr)), start(gr), end(gr))]
    gr$startCodon <- substring(fastaSeq[as.integer(match(seqnames(gr), fastaHeads))], start(gr), start(gr) + 2)
    gr$stopCodon <- substring(fastaSeq[as.integer(match(seqnames(gr), fastaHeads))], end(gr) - 2, end(gr))
    gr$context <- substring(fastaSeq[as.integer(match(seqnames(gr), fastaHeads))], start(gr) - 3, start(gr) + 3)
    gr$minus3 <- substring(fastaSeq[as.integer(match(seqnames(gr), fastaHeads))], start(gr) - 3, start(gr) - 3)
    gr$plus1 <- substring(fastaSeq[as.integer(match(seqnames(gr), fastaHeads))], start(gr) + 3, start(gr) + 3)
    gr
  }

lengthDist <- function(riboDat, add = FALSE, legend = NULL, ...)
  {
    lens <- lapply(riboDat@riboGR, function(gr) table(width(gr)) / length(gr))
    if(!add) {
#      xlim <- range(as.numeric(unlist(lapply(lens, names))))
#      if("ylim" %in% names(list(...))) ylim <- list(...)$ylim else ylim <- c(0, 1)
      do.call("plot", modifyList(list(x = NA, y = NA, xlim = range(as.numeric(unlist(lapply(lens, names)))), ylim = c(0, 1), ylab = "Proportion of aligned reads", xlab = "Length of read"), list(...)))
    }
    args <- modifyList(list(col = rainbow(length(riboDat@riboGR)), lwd = 1, lty = 1), list(...))
    args$col <- rep(args$col, length(riboDat@riboGR))
    args$lty <- rep(args$lty, length(riboDat@riboGR))

    for(ii in 1:length(lens)) {
      cargs <- args
      cargs$col <- cargs$col[ii]
      cargs$lty <- cargs$lty[ii]
      cargs[!names(cargs) %in% c("x", "y")]
      do.call(lines, c(list(y = as.numeric(lens[[ii]]), x = as.numeric(names(lens[[ii]]))), cargs))
    }
  
    if(!is.null(legend)) do.call(graphics::legend, modifyList(args[!names(args) %in% c("ylim", "cex.lab", "cex.axis")], list(x = "topright", legend = legend)))
  }

.readAlignments <-
  function(filenames, columns, header, seqnames, zeroIndexed) {
    positiveOnly = TRUE
    if(missing(seqnames)) seqnames <- NULL
    GRLs <- lapply(filenames, function(file) {
      if(length(grep("\\.(bam|BAM)$", file)) > 0) {
        x <- scanBam(file)
        fdat <- data.frame(strand = x[[1]]$strand, seqname = x[[1]]$rname, start = x[[1]]$pos, sequence = I(as.character(x[[1]]$seq)))
        fdat <- fdat[!is.na(fdat[,2]),]
      } else {
        fdat <- read.delim(file, as.is = TRUE, header = header)[,columns]
      }
      if(positiveOnly) fdat <- fdat[fdat[,1] == "+",]
      if(!is.null(seqnames)) {
        fdat <- fdat[fdat[,2] %in% seqnames,]
        fsn <- seqnames
      } else fsn <- unique(fdat[,2])
      
      GRL <- GRanges(                 
               seqnames = factor(fdat[,2], levels = fsn),
               IRanges(start = fdat[,3] + as.integer(zeroIndexed), width = nchar(fdat[,4])),
               strand = fdat[,1])
      
      
      message(".", appendLF = FALSE)
      GRL
    })
    names(GRLs) <- gsub("^.*/", "", filenames)
    GRLs
  }

readRibodata <-
function(riboFiles, rnaFiles, columns = c(strand = 1, seqname = 2, start = 3, sequence = 4), zeroIndexed = FALSE, header = FALSE, replicates, seqnames) {
  riboDat <- new("riboData", replicates = as.factor(replicates))
  message("Reading ribosomal files...", appendLF = FALSE)
  riboDat@riboGR <- .readAlignments(riboFiles, columns = columns, header = header, seqnames, zeroIndexed = zeroIndexed)
  message("done!")
  if(!missing(rnaFiles)) {
    message("Reading rna files...", appendLF = FALSE)
    riboDat@rnaGR <- .readAlignments(rnaFiles, columns = columns, header = header, seqnames, zeroIndexed = zeroIndexed)
    message("done!")
  }
  riboDat
}

.prepareSlice <-
  function(slices, array) {
    slice <- paste(
               paste(
                 sapply(slices, function(x)
                        if(!is.null(x)) {
                          wdif <- which(diff(x) != 1)
                          paste("c(", paste(sapply(lapply(split(x, rep(1:(length(wdif) + 1), c(wdif, length(x)) - c(1, wdif + 1) + 1)), range), paste, collapse = ":"), collapse = ","), ")", sep = "")
                        } else return("")),                      
                 collapse = ","),
               paste(rep(",", length(dim(array)) - length(slices)), collapse = ""), sep = "")
    slice
  }

.sliceArray <-
  function(slices, array, drop = FALSE) {
    if((is.vector(array) & sum(!sapply(slices, is.null)) > 1) || (is.array(array) & length(slices) > length(dim(array)))) warning("dimensions of slice exceed dimensions of array")
    if(is.vector(array)) return(array[slices[[min(which(!sapply(slices, is.null)))]]])
    dropText <- c(", drop = FALSE", ", drop = TRUE")[as.numeric(drop) + 1]
    slice <- .prepareSlice(slices, array)
    sarray <- eval(parse(text = paste("array[", slice, dropText, "]", sep = "")))
    sarray
  }

setClass("riboCoding", representation(CDS = "GRanges",
                                      hits = "array",
                                      unqHits = "array",
                                      replicates = "factor"))
setClass("riboData", representation(riboGR = "list",
                                    rnaGR = "list",
                                    replicates = "factor"))

filterHits <-
    function(fCs, lengths = 27, frames, hitMean = 10, unqhitMean = 1, ratioCheck = TRUE, fS) {

        if(is.list(fS)) fS <- Reduce("+", fS)
    if(missing(frames)) frames <- list(0:2)
    if(!is.list(frames)) frames <- list(frames)
    if(length(frames) == 1) frames <- rep(frames, length(lengths))
    if(length(lengths) == 1) lengths <- rep(lengths, length(frames))
    if(length(frames) != length(lengths)) stop("Length of 'lengths' parameter and 'frames' parameter must be equal (or one) if given")
    
    fH <- do.call("cbind", lapply(levels(fCs@replicates), function(rep) {
      rowMeans(Reduce("+", lapply(1:length(lengths), function(ll) {
        fCs@hits[,which(fCs@replicates == rep),as.character(frames[[ll]]), as.character(lengths[ll]), drop = FALSE]
      }))) > hitMean
    }))
    
    ufH <- do.call("cbind", lapply(levels(fCs@replicates), function(rep) {
      rowMeans(Reduce("+", lapply(1:length(lengths), function(ll) {
        fCs@unqHits[,which(fCs@replicates == rep),as.character(frames[[ll]]), as.character(lengths[ll]), drop = FALSE]
      }))) > unqhitMean
    }))
    
    filtration <- which(rowSums(fH, na.rm = TRUE) > 0 & rowSums(ufH, na.rm = TRUE) > 0)
    ffCs <- fCs[filtration,]
    
    if(ratioCheck) {
      trues <- sapply(1:length(lengths), function(ll, fS) {
        len <- lengths[ll]
        lenfram <- frames[[ll]]
        keep <- rep(TRUE, nrow(ffCs@hits))
        if(length(lenfram) != 3 || !all(sort(lenfram) == 0:2)) {
          sumhits <- apply(ffCs@hits[,,,as.character(len),drop = FALSE], c(1,3), sum)
          fps <- which(rowSums(sumhits[,as.character(lenfram),drop = FALSE]) < apply(sumhits[,!colnames(sumhits) %in% as.character(lenfram),drop = FALSE], 1, max))
          if(length(fps) > 0) {
            reject <- fps[sapply(fps, function(ff, fS) {
              maxframe <- which.max(sumhits[ff,]) - 1
              maxfS <- which.max(fS[,as.character(len)]) - 1
              rmap <- sumhits[ff, 1 + ((0:2 - (maxfS - maxframe)) %% 3)]
              compdat <- rbind(c(rmap[maxfS + 1], sum(sumhits[ff,as.character(lenfram)])),
                               c(max(fS[,as.character(len)]), sum(fS[1 + ((lenfram - (maxframe - maxfS)) %% 3), as.character(len)])))
              suppressWarnings(if(which.max(compdat[,2] / compdat[,1]) == 2 | chisq.test(compdat)$p.value > 0.05) return(TRUE) else return(FALSE))
            }, fS = fS)]
            if(length(reject) > 0) keep[reject] <- FALSE
          }
        }
        return(keep)
      }, fS = fS)
      ffCs <- ffCs[rowSums(trues) > 0,]
    }
    
    ffCs
  }
  

plotTranscript <-
function(transcript, coordinates, annotation, riboData, length = 27, frameShift = 0, cap, riboScale, rnaScale, xlim, main, note = "", libScales, ...) {
#  refseq <- solveMatch$refseq[solveMatch[,1] == transcript]
#  annotation <- solveMatch$annotation[solveMatch[,1] == transcript]

  alignments <- riboData@riboGR
  if(length(alignments) > 0 & is.null(dev.list()))
    par(mfrow = c(length(alignments),1), mar = c(2, 4, 2, 2))

  transceiling <- max(sapply(1:length(alignments), function(ii) {
    align <- alignments[[ii]]
    max(end(align)[as.character(seqnames(align)) == transcript])
  }))

  if(length(riboData@rnaGR) > 0) {
    transceiling <- max(c(transceiling, sapply(1:length(riboData@rnaGR), function(ii) {
      align <- riboData@rnaGR[[ii]]
      max(end(align)[as.character(seqnames(align)) == transcript])
    })))
  }
  
  if(!missing(coordinates)) transceiling <- max(c(transceiling, end(coordinates)[as.character(seqnames(coordinates)) == transcript]))
  
  for(ii in 1:length(alignments)) {    
      
      plus27GRL <- alignments[[ii]]
      allen <- plus27GRL[which(as.character(seqnames(plus27GRL)) == transcript & width(plus27GRL) == length)]
      
      createMat <- function(allen) {
                                        #if(any(!is.null(allen$startCodon))) startCodon <- allen$startCodon else startCodon <- 0
                                        #tabz <- table(start(allen) - startCodon)
          tabz <- table(start(allen) - frameShift)
          tabzz <- rep(0, ceiling(transceiling / 3) * 3)
          tabzz[as.numeric(names(tabz))] <- tabz  
          matz <- matrix(tabzz, nrow = 3);
          colnames(matz) <- (1:(ceiling(transceiling / 3) * 3))[1:(ceiling(transceiling / 3)) * 3 - 2] + 1
          matz
      }
      
      matz <- createMat(allen)
      if(!missing(cap)) matz[matz > cap] <- cap
      if(!missing(libScales)) matz <- matz / libScales$riboLS[ii] * mean(libScales$riboLS)
                                        #    if(ii < length(alignments)) colnames(matz) <- NULL
      if(missing(xlim))
          xlim <- c(0, ncol(matz) * 3)
      
      if(length(riboData@rnaGR) > 0) {      
          covmRNA <- riboData@rnaGR[[ii]]
          cov <- coverage(covmRNA[which(as.character(seqnames(covmRNA)) == transcript)])
          cov <- as.integer(cov[[which(names(cov) == transcript)]])
          if(!missing(libScales)) matz <- matz / libScales$rnaLS[ii] * mean(libScales$rnaLS)
      } else cov <- 0
    
      if(!missing(riboScale)) maxribo <- riboScale[ii] else maxribo <- max(matz)
      if(!missing(rnaScale)) maxrna <- rnaScale[ii] else maxrna <- max(cov)
      if(missing(main)) main = paste(names(alignments)[ii], " :: ", transcript, sep = "")
      ymax <- max(pretty(0:maxribo))
    
    plot(NA, NA, axes = FALSE, ylim = c(0, ymax), xlim = c(floor(xlim[1]), ceiling(xlim[2])), xlab = "", ylab = "")

    bp <- barplot(matz, beside = TRUE, plot = FALSE, space = c(0,1), width = 0.75, xlim = xlim, ...)

    if(length(riboData@rnaGR) > 0) {      
      pretcov <- pretty(0:maxrna)
      cov <- cov / max(pretty(0:maxrna)) * max(pretty(0:maxribo))
      suppressWarnings(axis(side = 4, at = c(pretcov / max(pretcov)) * max(pretty(0:maxribo)), labels = pretcov, ...))
      rect(as.vector(bp)[1:length(cov)] - 0.5, 0, as.vector(bp)[1:length(cov)] + 0.5, cov, col = "light grey", border = "light grey")
    }

    bp <- barplot(matz, beside = TRUE, border = c("red", "green", "blue"), col = c("red", "green", "blue"), main = main, axes = FALSE, ylim = c(0, ymax * c(1, 1.2)[as.integer(ii == 1) + 1]), 
                  xlim = c(floor(xlim[1] / 3 * 3), ceiling(xlim[2] / 3 * 3)),
                  add = TRUE, plot = TRUE, space = c(0,1), width = 0.75)
    
    if(ii == 1 & !missing(annotation)) {
      rect(xleft = as.vector(bp)[start(annotation)], xright = as.vector(bp)[end(annotation)], ybottom = ymax *1.1, ytop = ymax * 1.2, col = "turquoise", border = "turquoise")    
      suppressWarnings(text(x = mean(as.vector(bp)[c(start(annotation), end(annotation))]), y = ymax * (1.1 + 1.2) / 2, labels = seqnames(annotation), ...))
    }
    
    suppressWarnings(axis(side = 2, pretty(0:ymax), ...))
    #if(ii == 1) text(x = 20, y = max(matz) * c(1.2, 1.1, 0.9), labels = c(refseq, annotation, note), pos = 4, cex = 0.7)
    
    if(!missing(coordinates)) {
      if(is.list(coordinates)) tw <- coordinates[[ii]][seqnames(coordinates[[ii]]) == transcript,] else tw <- coordinates[seqnames(coordinates) == transcript,]
      if(length(tw) > 0) {
        segcols <- rgb(c(0.8,0,0), c(0,0.8,0), c(0,0,0.8), alpha = 0.8)
        segments(as.vector(bp)[start(tw)] - 1, ymax * (1.015 + ((start(tw) - 1) %% 3) * 0.005), as.vector(bp)[end(tw)] - 1, ymax * (1.015 + ((start(tw) - 1) %% 3) * 0.005), col = segcols[1 + ((start(tw) - 1) %% 3)], lwd = 3)
      }
    }  
  }
  NULL
}

frameShift <- function(...) {
  stop("This function is obsolete. Please use readingFrame instead.")
}

readingFrame <- function(rC, lengths = 26:30) {    

    frameCounts <- lapply(1:ncol(rC@hits), function(ii) {
        frameCounts <- sapply(lengths, function(length)
            sapply(0:2, function(frame) sum(rC@hits[,ii,as.character(frame), as.character(length)])))

        colnames(frameCounts) <- lengths
        rownames(frameCounts) <- 0:2
        
        frameCounts <- rbind(frameCounts, frame.ML = apply(frameCounts, 2, function(x) which.max(x)) - 1)
    })
                                        #frameShift <- which.max(frameCounts) - 1
                                        #c(frameShift, max(frameCounts) / sum(frameCounts))
    
  
  #colnames(frameShifts) <- as.character(lengths)
  #rownames(frameShifts) <- c("frameShift", "weighting")
                                        #frameShifts
    if(is.list(frameCounts) & length(frameCounts) == 1) frameCounts <- frameCounts[[1]]
    frameCounts
}


plotFS <- function(fS, lengths, legend.text = c("Frame 0", "Frame 1", "Frame 2"), ...)
    {

        if(!is.list(fS)) fS <- list(fS)
        if(is.null(names(fS))) names(fS) <- 1:length(fS)
        
        for(ff in 1:length(fS)) {
            if(!missing(lengths)) colsel <- which(colnames(fS[[ff]]) %in% as.character(lengths)) else colsel <- 1:ncol(fS[[ff]])   
            barplot(fS[[ff]][1:3, colsel], beside = TRUE, col = rainbow(3, s = 0.7), border = rainbow(3, s = 0.7), legend.text = legend.text, main = names(fS)[ff], ...)
        }
    
#    if(legend) legend(x = "topright", bty = "n", , fill = rainbow(3, s = 0.7), border = rainbow(3, s = 0.7), )
  }
  

plotCDS <- function(coordinates, riboDat, lengths = 27, min5p = -20, max5p = 200, min3p = -200, max3p = 20, cap, main = "", plot = TRUE, ...) {

  min5p <- floor(min5p / 3) * 3; max5p <- (ceiling(max5p / 3) * 3) - 1
  min3p <- floor(min3p / 3) * 3; max3p <- (ceiling(max3p / 3) * 3) - 1

  alignments <- riboDat@riboGR
  if(plot && length(alignments) > 0 & is.null(dev.list()))
    par(mfrow = c(length(alignments), 1))
  if(missing(cap)) cap <- NULL
  
  lenmatz <- lapply(lengths, function(length) {
    alignments <- lapply(alignments, function(al) al[width(al) == length])  
    matzes <- lapply(1:length(alignments), function(ii) {
      allen <- alignments[[ii]]
      redcod <- coordinates[as.character(seqnames(coordinates)) %in% seqlevels(allen),]
#      allen <- allen[match(seqnames(redcod), seqlevels(allen))]
      starts <- split(start(allen), as.character(seqnames(allen)))
      rcmat <- match(names(starts), as.character(seqnames(redcod)))

      strod <- vector("list", length(redcod))
      strod[rcmat[!is.na(rcmat)]] <- starts[!is.na(rcmat)]
      
      
      makeMatz <- function(whichEnd, min, max) {
        if(whichEnd == "5p") fixedPoints <- start(redcod) else fixedPoints <- end(redcod) - 2
        widthcod <- width(redcod)
#        lencods <- cbind(unlist(strod) - rep(fixedPoints, sapply(strod, length)),
#                         1 / (rep(sapply(strod, length),
#                                  sapply(strod, length)) / rep(width(redcod), sapply(strod, length))), rep(1:length(strod), sapply(strod, length)))

        adjstrod <- split(unlist(strod) - rep(fixedPoints, sapply(strod, length)), factor(rep(1:length(strod), sapply(strod, length)), levels = 1:length(strod)))
        ctstrod <- do.call("rbind", lapply(adjstrod, function(x) if(is.null(x)) return(rep(0, max - min + 1)) else table(factor(x[x >= min & x<= max], levels = min:max))))
        weights <- 1 / (sapply(strod, length) / (rep(width(redcod)/1000)))
        weightMean <- apply(ctstrod[weights < Inf,,drop = FALSE], 2, weighted.mean, weights[weights < Inf]) 
                                                                          
#        lencods <- lencods[lencods[,1] >= min & lencods[,1] <= max,]
#        spllen <- split(lencods[,2], factor(lencods[,1], levels = min:max))
#        weightsum <- sapply(spllen, function(x) sum(1/x))    
        matz <- matrix(weightMean, nrow = 3);
        colnames(matz) <- (min:max)[1:((max - min + 1) / 3) * 3 - 2]
        matz
      }
      
      if(min5p < max5p) matz5p <- makeMatz("5p", min = min5p, max = max5p) else matz5p <- NULL
      if(min3p < max3p) matz3p <- makeMatz("3p", min = min3p, max = max3p) else matz3p <- NULL
      matz <- cbind(matz5p, matrix(NA, ncol = max(1, min(25, round(sum(ncol(matz5p), ncol(matz5p)) * 0.1))), nrow = 3), matz3p)      
      if(!is.null(cap)) matz[matz > cap] <- cap
      
      if(plot) {
        bw <- barplot(matz, beside = TRUE, col = rainbow(3, s = 0.7), border = rainbow(3, s = 0.7), main = main, ylim = c(0, max(matz, na.rm = TRUE)), axisnames = FALSE, space = c(0, 0.25), ylab = "Mean number of reads", xlab = "Base position relative to CDS",...)        
        if(min5p < max5p) {
          pretty5p <- pretty(min5p:max5p); pretty5p <- pretty5p[pretty5p >= min5p]; pretty5p <- pretty5p[pretty5p <= max5p]; pretty5p <- unique(pretty5p)
          prettystart <- pretty5p; prettystart[prettystart == 0] <- "start"
          axis(side = 1, at = as.vector(bw)[(pretty5p - min5p + 1)], labels = prettystart, lwd = 0, lwd.ticks = 1, ...)
        }
        if(min3p < max3p) {
          pretty3p <- pretty(min3p:max3p); pretty3p <- pretty3p[pretty3p >= min3p]; pretty3p <- pretty3p[pretty3p <= max3p]; pretty3p <- unique(pretty3p)
          prettystop <- pretty3p; prettystop[prettystop == 0] <- "stop"
          axis(side = 1, at = as.vector(bw[,max(which(is.na(matz[1,])) + 1):ncol(bw)])[pretty3p - min3p + 1], labels = prettystop, lwd = 0, lwd.ticks = 1, ...)
        }
        
      }
      matz
    })
  })
  invisible(lenmatz)
}

test_findCDS <- function() {
  fcds <- findCDS("../extdata/unit_test.fasta", startCodon = c("ATG"), stopCodon = c("TAG", "TAA", "TGA"))
  checkTrue(all(as.data.frame(fcds) ==
      data.frame(seqnames = factor(c("ut_1", "ut_3"), levels = c("ut_1", "ut_2", "ut_3")), start = c(1,2), end = c(7,10), width = c(7,9), strand = factor(c("*", "*"), levels = c("+", "-", "*")), frame = c(0, 1))))
}

test_readRibodata <- function() {
  datadir <- system.file("extdata", package = "riboSeq")
  chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")  
  fastaCDS <- findCDS(fastaFile = chlamyFasta,
                      startCodon = c("ATG"),
                      stopCodon = c("TAG", "TAA", "TGA"))
  rR <- readRibodata(paste(datadir, "/chlamy236_plus_deNovo_plusOnly_Index17_short", sep = ""), replicates = c(1))
  fCs <- frameCounting(rR, fastaCDS)
  checkTrue(all(frameShift(rC = fCs)[,2] == c(0,2,0,1)))
}

sliceCounts <-
function(rC, lengths = 27, frames) {  
  if(missing(frames)) frames <- list(0:2)
  if(!is.list(frames)) frames <- list(frames)
  if(length(frames) == 1) frames <- rep(frames, length(lengths))
  if(length(lengths) == 1) lengths <- rep(lengths, length(frames))
  if(length(frames) != length(lengths)) stop("Length of 'lengths' parameter and 'frames' parameter must be equal (or one) if given")

  fH <- do.call("cbind", lapply(1:ncol(rC@hits), function(jj) {
    (Reduce("+", lapply(1:length(lengths), function(ll) {
      rC@hits[,jj,as.character(frames[[ll]]), as.character(lengths[ll])]
    })))
  }))

  
  fH

}

rnaCounts <- function(riboDat, CDS) {
  z <- do.call("cbind", lapply(riboDat@rnaGR, function(x) table(factor(subjectHits(findOverlaps(x,CDS)), levels = 1:length(CDS)))))
}

.oldframeCounting <-
function(riboDat, fastaCDS, lengths = 25:30)
  {
    message("Calling frames...", appendLF = FALSE)

    if(!("frame" %in% names(values(fastaCDS)))) fastaCDS$frame <- (start(fastaCDS) - 1) %% 3
    
    fr0GR <- fastaCDS[fastaCDS$frame == 0]
    fr1GR <- fastaCDS[fastaCDS$frame == 1]
    fr2GR <- fastaCDS[fastaCDS$frame == 2]

    frameCalls <- lapply(riboDat@riboGR, function(gral, lengths) {
#      gral$frame <- (start(gral) - 2) %% 3
      gral$frame <- (start(gral) - 1 - 0) %% 3
      if(length(fr0GR) > 0) fr0 <- .tableOverlaps(fr0GR, gral, lengthRange = lengths) else fr0 <- new("riboCoding", hits = array(dim=c(0,1,3,length(lengths))), unqHits = array(dim=c(0,1,3,length(lengths))))
      message(".", appendLF = FALSE)
      gral$frame <- (start(gral) - 1 - 1) %% 3
      if(length(fr1GR) > 0) fr1 <- .tableOverlaps(fr1GR, gral, lengthRange = lengths) else fr1 <- new("riboCoding", hits = array(dim=c(0,1,3,length(lengths))), unqHits = array(dim=c(0,1,3,length(lengths))))
      message(".", appendLF = FALSE)
      gral$frame <- (start(gral) - 1 - 2) %% 3
      if(length(fr2GR) > 0) fr2 <- .tableOverlaps(fr2GR, gral, lengthRange = lengths) else fr2 <- new("riboCoding", hits = array(dim=c(0,1,3,length(lengths))), unqHits = array(dim=c(0,1,3,length(lengths))))
      message(".", appendLF = FALSE)
      rc <- new("riboCoding",
          CDS = c(fr0@CDS, fr1@CDS, fr2@CDS),
          hits = do.call("abind", args = list(list(fr0@hits, fr1@hits, fr2@hits), along = 1)),
          unqHits = do.call("abind", args = list(list(fr0@unqHits, fr1@unqHits, fr2@unqHits), along = 1)))
      rc
    }, lengths = lengths)
    message(".done!", appendLF = TRUE)
    fCs <- new("riboCoding")
    fCs@hits <- do.call("abind", args = list(lapply(frameCalls, function(x) x@hits), along = 2))
    fCs@unqHits <- do.call("abind", args = list(lapply(frameCalls, function(x) x@unqHits), along = 2))
    fCs@CDS <- frameCalls[[1]]@CDS
    fCs@replicates <- riboDat@replicates
    fCs
  }


frameCounting <- function(riboDat, cds, lengths = 25:30, offset5p = 0, offset3p = 0)
  {
      message("Calling frames...", appendLF = FALSE)

      getHits <- function(rgr, offset5p, offset3p) {
          message(".", appendLF = FALSE)
          rgr <- rgr[width(rgr) %in% lengths]
          mcds <- cds; start(mcds) <- pmax(0, start(mcds) - offset5p); end(mcds) <- pmax(start(mcds), end(mcds) - offset3p)
          fo <- findOverlaps(mcds, rgr)
          dat <- cbind.data.frame(cds = factor(queryHits(fo), levels = 1:length(cds)),
                                  frame = factor((start(rgr)[subjectHits(fo)] - start(cds[queryHits(fo)])) %% 3, levels = 0:2),
                                  length = factor(width(rgr)[subjectHits(fo)], levels = lengths))
                           
          
          list(hits = table(dat), unqHits = table(dat[!duplicated(rgr)[subjectHits(fo)],]))
      }

      riboCounts <- lapply(riboDat@riboGR, getHits, offset5p = offset5p, offset3p = offset3p)
      #rnaCounts <- lapply(riboDat@rnaGR, getHits, offset5p = offset5p, offset3p = offset3p)
      message("done!")
      
      fCs <- new("riboCoding")
      fCs@hits <- aperm(do.call("abind", args = list(lapply(riboCounts, function(x) x$hits), along = 0)), c(2,1,3,4))
      fCs@unqHits <- aperm(do.call("abind", args = list(lapply(riboCounts, function(x) x$unqHits), along = 0)), c(2,1,3,4))
      if(length(dim(fCs@hits)) == 3) fCs@hits <- array(fCs@hits, c(dim(fCs@hits)[1], 1, dim(fCs@hits)[2:3]))
      if(length(dim(fCs@unqHits)) == 3) fCs@unqHits <- array(fCs@unqHits, c(dim(fCs@unqHits)[1], 1, dim(fCs@unqHits)[2:3]))

      dimnames(fCs@hits) <- list(NULL, names(riboDat@riboGR), 0:2, lengths)
      dimnames(fCs@unqHits) <- list(NULL, names(riboDat@riboGR), 0:2, lengths)
      
      fCs@CDS <- cds
      fCs@replicates <- riboDat@replicates      
      
      fCs
   
  }      

logoContext <- function(cds, ...) {
    baseTab <- apply(
        do.call("rbind", lapply(strsplit(cds$context, ""), function(x) c(rep(NA, 7 -length(x)), x)))
      , 2, function(x) table(factor(x, levels = c("A", "C", "G", "T"))))
    p <- makePWM(t(t(baseTab) / colSums(baseTab)))
    seqLogo(p, ...)
    invisible(baseTab)
}

%\VignetteIndexEntry{riboSeq}
%\VignettePackage{riboSeq}

\documentclass[a4paper]{article}

%\usepackage{rotating}

\title{riboSeq}
\author{Thomas J. Hardcastle}

\begin{document}

\maketitle

Load the riboSeq library.

<<>>=
  library(riboSeq)
@

Set the working directory to the data directory.

<<>>=
setwd(system.file("extdata", package = "riboSeq"))
@ 

The \verb'fastaCDS' function can be used to guess at potential coding sequences from a fasta file containing mRNA transcripts (note; do not use this on a genome!). These can also be loaded into a GRanges object from an annotation file.

<<>>=
fastaCDS <- findCDS(fastaFile = "rsem_chlamy236_deNovo.transcripts.fa", startCodon = c("ATG"), stopCodon = c("TAG", "TAA", "TGA"))
@ 

The aligned ribosomal (and RNA) data can be read in using the \verb'readRibodata' function. These will probably have been created with a bowtie process along the lines of ``bowtie -p 4 --norc -k 100 --suppress 1,6,7,8 chlamy236_plus_deNovo 17_trimmed_filtered.fq  chlamy236_plus_deNovo_plusOnly_Index17''. Using this ``--suppress'' option will give the minimal data required for \verb'riboSeq' and the correct columns specification for the default \verb'readRibodata' function parameters.

<<>>=
ribofiles <- paste("chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste("chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT", "M", "M"))
@ 

The alignments can be assigned to frames relative to the coding coordinates with the \verb'frameCounting' function.

<<>>=
fCs <- frameCounting(riboDat, fastaCDS)
@ 

These can be filtered on the mean number of hits and unique hits within replicate groups to give plausible candidates for coding.

<<>>=
ffCs <- filterHits(fCs, hitMean = 50, unqhitMean = 10)
@ 

The estimated frame shifts, relative to coding start, can be estimated from the frame calling (or from a set of coordinates and alignment data) for each n-mer. The weighting decribes the proportion of n-mers fitting with the most likely frameshift.
<<>>=
frameShift(rC = ffCs) 
@ 

We can plot the total alignment at the 5' and 3' ends of coding sequences using the \verb'plotCDS' function. The frames are colour coded; frame-0 is red, frame-1 is green, frame-2 is blue. 
<<>>=
plotCDS(coordinates = ffCs@CDS, riboDat = riboDat, lengths = 27)
@ 

Note the frameshift for 28-mers.
<<>>=
plotCDS(coordinates = ffCs@CDS, riboDat = riboDat, lengths = 28)
@ 


We can plot the alignment over an individual transcript sequence using the \verb'plotTranscript' function.
<<>>=

@ 

\end{document}


<<>>=
names <- NULL
for(ff in rnafiles) {
  rdat <- read.delim(ff, as.is = TRUE, header = FALSE)
  if(is.null(names)) {
    tabdat <- table(rdat[,2])
    names <- sample(names(tabdat[tabdat >= 1e2 & tabdat < 1e4]), 50)
  }
  rdat <- rdat[rdat[,2] %in% names,]
  write.table(rdat, file = ff, sep = "\t", row.names = FALSE, col.names = FALSE)
}
  
@ 


z <- scan("~/Code/Betty_ribosome_3/rsem_chlamy236_deNovo.transcripts.fa", what = "character")
znam <- which(gsub(">", "", z[grep(">", z)]) %in% names)

%\VignetteIndexEntry{riboSeqR}
%\VignettePackage{riboSeqR}

\documentclass[a4paper]{article}

\usepackage{subfig}

\title{riboSeqR}
\author{Thomas J. Hardcastle, Betty Y.W. Chung}

<<<style-Sweave, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@ 

\begin{document}



\maketitle

\section*{Introduction}

Ribosome profiling extracts those parts of a coding sequence currently bound by a ribosome (and thus, are likely to be undergoing translation). Ribosomes typically cover between 20-30 bases of the mRNA (dependant on conformational changes) and move along the mRNA three bases at a time. Sequenced reads of a given length are thus likely to lie predominantly in a single frame relative to the start codon of the coding sequence. This package presents a set of methods for parsing ribosomal profiling data from multiple samples and aligned to coding sequences, inferring frameshifts, and plotting the average and transcript-specific behaviour of these data. Methods are also provided for extracting the data in a suitable form for differential translation analysis. For a fuller description of these methods and further examples of their use, see Chung \& Hardcastle \textsl{et al} (2015) \cite{chung}.

\section*{Getting Data}

\verb'riboSeqR' currently reads alignment data from BAM files, or from flat text files, although BAM format is recommended.

\section*{Workflow Example}

Begin by loading the riboSeqR library.

<<>>=
library(riboSeqR)
@

Identify the data directory for the example data. 

<<>>=
datadir <- system.file("extdata", package = "riboSeqR")
@ 

The \Rfunction{fastaCDS} function can be used to guess at potential coding sequences from a (possibly compressed; see \Rfunction{base::file}) fasta file containing mRNA transcripts (note; do not use this on a genome!). These can also be loaded into a \Rclass{GRanges} object from an annotation file.

<<>>=
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))
@ 

The ribosomal and RNA (if available) alignment files are specified.
<<>>=
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")
@ 

The aligned ribosomal (and RNA) data can be read in using the \Rfunction{readRibodata} function. The columns can be specified as a parameter of the \Rfunction{readRibodata} function if the data in the alignment files are differently arranged.

<<>>=
riboDat <- readRibodata(ribofiles, replicates = c("WT", "WT", "M", "M"))
@ 

The alignments can be assigned to frames relative to the coding coordinates with the \Rfunction{frameCounting} function.

<<>>=
fCs <- frameCounting(riboDat, fastaCDS)
@ 

The predominant reading frame, relative to coding start, can be estimated from the frame calling (or from a set of coordinates and alignment data) for each n-mer. The weighting decribes the proportion of n-mers fitting with the most likely frameshift. The reading frame can also be readily visualised using the \Rfunction{plotFS} function.

<<<<fig = FALSE, label=frameshift, height = 10, width = 12>>=
fS <- readingFrame(rC = fCs); fS
plotFS(fS)
@ 

\begin{figure}[!ht]
\begin{center}
<<label=frameshift, fig=TRUE,echo=FALSE>>=
<<frameshift>>
@ 
\caption{Number of n-mers in each frame relative to coding start. 27-mers are predominantly in frame-1, while 28-mers are chiefly in frame-0.}
\label{fig:frameshift}
\end{center}
\end{figure}


These can be filtered on the mean number of hits and unique hits within replicate groups to give plausible candidates for coding. Filtering can be limited to given lengths and frames, which may be inferred from the output of the \Rfunction{readingFrame} function.

<<>>=
ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(1, 0), 
                   hitMean = 50, unqhitMean = 10, fS = fS)
@ 

We can plot the total alignment at the 5' and 3' ends of coding sequences using the \Rfunction{plotCDS} function. The frames are colour coded; frame-0 is red, frame-1 is green, frame-2 is blue. 
<<<<fig = FALSE, label=plotcds27, height = 6, width = 8>>=
plotCDS(coordinates = ffCs@CDS, riboDat = riboDat, lengths = 27)
@ 
Note the frameshift for 28-mers.
<<<<fig = FALSE, label=plotcds28, height = 6, width = 8>>=
plotCDS(coordinates = ffCs@CDS, riboDat = riboDat, lengths = 28)
@ 

\begin{figure}[!ht]
\centering
<<label=figcds27, fig=TRUE,echo=FALSE>>=
<<plotcds27>>
@ 
\label{fig:cds27}
\caption{Average alignment of 27-mers to 5' and 3' ends of coding sequences.}
\end{figure}


\begin{figure}[!ht]
\centering
<<label=figcds28, fig=TRUE,echo=FALSE>>=
<<plotcds28>>
@ 
\label{fig:cds28}
\caption{Average alignment of 28-mers to 5' and 3' ends of coding sequences.}
\end{figure}



We can plot the alignment over an individual transcript sequence using the \Rfunction{plotTranscript} function. Observe that one CDS (on the right) contains the 27s in the same phase as the CDS (they are both red) while the putative CDSes to the left are not in phase with the aligned reads, suggesting either a sequence error in the transcript or a misalignment. The coverage of RNA sequenced reads is shown as a black curve (axis on the right).
<<<<fig = FALSE, label=plottranscript, height = 10, width = 12>>=
plotTranscript("CUFF.37930.1", coordinates = ffCs@CDS, 
               riboData = riboDat, length = 27, cap = 200)               
@ 

\begin{figure}[!ht]
\begin{center}
<<label=figtran, fig=TRUE,echo=FALSE>>=
<<plottranscript>>
@ 
\caption{Alignment to individual transcript.}
\label{fig:trans}
\end{center}
\end{figure}

We can extract the counts from a \Rclass{riboCoding} object using the \Rfunction{sliceCounts} function

<<>>=
riboCounts <- sliceCounts(ffCs, lengths = c(27, 28), frames = list(0, 2))
@ 

Counts for RNA-sequencing can be extracted using from the riboData object and the coding coordinates using the \Rfunction{rnaCounts} function. This is a relatively crude counting function, and alternatives have been widely described in the literature on mRNA-Seq.

<<>>=
rnaCounts <- rnaCounts(riboDat, ffCs@CDS)
@ 

These data may be used in an analysis of differential translation through comparison with the RNA-seq data. See the description of a beta-binomial analysis in the \Biocpkg{baySeq} vignettes for further details.

<<>>=
library(baySeq)

pD <- new("countData", replicates = ffCs@replicates, 
          data = list(riboCounts, rnaCounts),
          groups = list(NDT = c(1,1,1,1), DT = c("WT", "WT", "M", "M")),
          annotation = as.data.frame(ffCs@CDS),
          densityFunction = bbDensity)
libsizes(pD) <- getLibsizes(pD)

pD <- getPriors(pD, cl = NULL)
pD <- getLikelihoods(pD, cl = NULL)
topCounts(pD, "DT", normaliseData = TRUE)
@

\section*{Session Info}

<<>>=
sessionInfo()
@ 

\begin{thebibliography}{99}
\bibitem{chung} BY Chung and TJ Hardcastle and JD Jones and N Irigoyen and AE Firth and DC Baulcombe and I Brierley \textsl{The use of duplex-specific nuclease in ribosome profiling and a user-friendly software package for Ribo-seq data analysis.} RNA (2015).
\end{thebibliography}

\end{document}

\name{plotCDS}
\alias{plotCDS}

\title{
Plots average ribosome footprint alignment to coding sequences at 5' and
3' ends.
}
\description{
For each sample, the average (normalised by translation abundance over
transcript) of the ribosome footprints of a given length alignments at
the 5' and 3' ends of all specified transcripts beginning at each base
relative to coding start/end are plotted. The bases are colour coded
relative to start codon.
}
\usage{
plotCDS(coordinates, riboDat, lengths = 27, min5p = -20, max5p = 200,
min3p = -200, max3p = 20, cap, main = "", plot = TRUE, ...)
}
\arguments{
  \item{coordinates}{
    Coordinates (as a \code{GRanges} object) of the coding sequences.
}
  \item{riboDat}{
    \code{\link{riboData}} object containing ribosome footprint data.
}
  \item{lengths}{
    Lengths of footprints to be plotted. May be given as a vector, in
    which case multiple plots will be produced.
}
  \item{min5p}{
    The distance upstream of the translation start to be plotted.
}
  \item{max5p}{
    The distance downstream of the translation start to be plotted.
}
  \item{min3p}{
    The distance upstream of the translation end to be plotted.
}
  \item{max3p}{
    The distance downstream of the translation end to be plotted.
  }
  \item{cap}{
    If given, caps the height of plotted values.
    }
  \item{main}{
    Title of the plot.
}
  \item{plot}{
    Should the acquired matrix of mean expression be plotted? Defaults
    to TRUE.
  }
  \item{...}{
    Additional arguments to be passed to 'plot' and 'axes'.
  }
}

\value{
Invisibly returns lists of lists of matrices containing weighted
averages plotted for each sample/length combination.
}
\author{
Thomas J. Hardcastle
}

\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M")) 

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)

# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = fCs, lengths = 27:28)

# filter coding sequences. 27-mers are principally in the 1-frame,
# 28-mers are principally in the 0-frame relative to coding start (see
# readingFrame function).

ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(0, 2), 
                   hitMean = 50, unqhitMean = 10, fS = fS)

plotCDS(coordinates = ffCs@CDS, riboDat = riboDat, lengths = 27)

}
\keyword{hplot}

\name{logoContext}
\alias{logoContext}

\title{
Produces a motif of coding start context
}
\description{
The findCDS function reports the immediate context of coding start. This
function uses the 'seqLogo' package to produce a motif of the contexts
reported.
}
\usage{
logoContext(cds, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{cds}{
    A GRanges object containing a '$context' value which defines the 7
    bases defining coding start context.
}
  \item{\dots}{
    Other values to be passed to the seqLogo function.
}
}
\value{
  A matrix containing counts of the different bases observed at each
  position of the 7-base context.
}
\author{
Thomas J. Hardcastle
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{plot}

\name{rnaCounts}
\alias{rnaCounts}
\title{
Extracts mRNA counts from a riboDat object for a set of coding sequence coordinates.
}
\description{
Takes mRNA count data from riboDat object, maps them to coding sequences
specified in GRanges object, and counts the total number of
hits. This is a crude approach intended to quickly produce comparable
data to ribosome footprint counts. More sophisticated alternatives,
addressing coverage variation, isoforms, multireads &c. have been widely
described in the literature on mRNA-seq analyses.
}
\usage{
rnaCounts(riboDat, CDS)
}

\arguments{
  \item{riboDat}{
    A \code{\link{riboData}} object containing the RNA-seq alignments.
}
  \item{CDS}{
    A \code{GRanges} object defining the coordinates of the coding
    sequences for which to acquire counts.
}
}
\details{
  The count data thus acquired can be compared to counts of ribosomal
  footprint data through a beta-binomial analysis (see vignette) to
  discover differential translation.
  }
\value{
  A matrix containing count data for the RNA-seq libraries.
}
\author{
Thomas J. Hardcastle
}

\seealso{
\code{\link{sliceCounts}}
}
\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M")) 

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)

# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = fCs, lengths = 27:28)

# filter coding sequences. 27-mers are principally in the 1-frame,
# 28-mers are principally in the 0-frame relative to coding start (see
# readingFrame function).

ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(1, 0), 
                   hitMean = 50, unqhitMean = 10, fS = fS)

# Extract counts of RNA hits from riboCount data.
rnaCounts <- rnaCounts(riboDat, ffCs@CDS)
}
\keyword{manip}

\name{riboCoding-class}
\docType{class}
\alias{riboCoding}
\alias{riboCoding-class}
\alias{[,riboCoding-method}
\alias{[,riboCoding,ANY-method}
\alias{[,riboCoding,ANY,ANY-method}
\alias{show,riboCoding-method}

\title{Class "riboCoding"}

\description{
  The \code{riboCoding} class contains a set of coordinates defining
  coding sequences, a set of replicate data for the experimental
  samples, an array of ribosome footprint abundances for each
  coding sequence split by size class and frame, and a similar array
  describing the abundance of unique sequences aligning within each
  coding sequence. 
}

\section{Slots}{
  \describe{
    \item{\code{CDS}:}{Object of class \code{"GRanges"} defining the
      coordinates of coding sequences.}
    \item{\code{hits}:}{An array describing the abundances of ribosome
      footprints, split by size class and frame (relative to coding start)
      for each of the coding sequences defined in the `CDS' slot.}
    \item{\code{unqHits}:}{An array describing the abundances of unique
      sequences of ribosome footprints, split by size class and frame
      (relative to coding start) for each of the coding sequences defined in
      the `CDS' slot.}
    \item{\code{replicates}:}{A factor defining the replicate structure
      of the samples for which data are held. Replicate samples will have
      the same level in this factor.}
    }
}

\section{Methods}{
  Methods `[' and `show' are defined for this class.
}

\author{Thomas J. Hardcastle}

\keyword{classes}

\name{plotTranscript}
\alias{plotTranscript}
\title{
Plots ribosome footprint abundance and mRNA coverage (if available) for
a specific transcript.
}
\description{
Abundances of ribosomal footprints of a given size class are plotted on
a transcript. The footprints are colour coded according to the first
base of the transcript, and not any coding start site, to allow for
multiple coding start sites on a given transcript. Coding regions may
simultaneously be plotted and colour coded under the same scheme.
}
\usage{
plotTranscript(transcript, coordinates, annotation, riboData, length =
27, frameShift = 0, cap, riboScale, rnaScale, xlim, main, note = "",
libScales, ...)
}
\arguments{
  \item{transcript}{
    The name of the transcript to be plotted.
  }
  \item{coordinates}{
    A GRanges object containing any coding regions on the transcript.
  }
  \item{annotation}{
    A GRanges object containing annotated coding coordinates to be
    plotted as bars above the figure.
  }
  \item{riboData}{
    A \code{\link{riboData}} object containing the ribosome footprint
    (and optionally, RNA-seq) data.
  }
  \item{length}{
    Size class of ribosome footprint data to be plotted.
  }
  \item{frameShift}{
    Frameshift for the ribosome footprint data. See Details.
  }
  \item{cap}{
   Cap on the largest value that will be plotted as an abundance of the
   ribosome footprint data.
  }
  \item{riboScale}{
    Scale to be used on the ribosome footprint axis.
  }
  \item{rnaScale}{
    Scale to be used on the RNA-seq coverage axis.
  }
  \item{xlim}{
    Limits of the bases of the transcript to be plotted (i.e., the
    x-axis). If missing, the full transcript will be plotted.
  }
  \item{main}{
    Optional title for the plot.
    }
  \item{note}{
    Additional note to be added to plot titles (in addition to transcript
    and sample names).
  }
  \item{libScales}{
    If supplied, library scaling factors for normalisation of ribosomal
    and RNA counts (see \code{\link{libScales}}).
    }
  \item{...}{
    Additional arguments to be passed to plotting function.
    }
}

\details{
  The readingFrame value allows the colour-coding of the ribosome
  footprints to be shifted so that the colours of the coding sequences match
  the colours of the ribosome footprint data. E.g., if 28-mers are
  predominantly in frame 2 relative to coding start, a value of
  `readingFrame=2' will ensure that 28-mers in a coding region will take
  the same colour as that coding region if they are in the correct
  relative frame.
}
\value{
NULL; plotting function.
}
\author{
Thomas J. Hardcastle
}


\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M"))

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)


# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = fCs, lengths = 27:28)

# filter coding sequences. 27-mers are principally in the 1-frame,
# 28-mers are principally in the 0-frame relative to coding start (see
# readingFrame function).

ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(1, 0), 
                   hitMean = 50, unqhitMean = 10, fS = fS)

plotTranscript("CUFF.37930.1", coordinates = ffCs@CDS, 
               riboData = riboDat, length = 27, cap = 200)               

}
\keyword{hplot}

\name{findCDS}
\alias{findCDS}
\title{
Parses a transcriptome file looking for start/stop codons in frame.
}
\description{
Looks in the fastaFile for defined start and stop codons in frame with
one another. Reports the discovered coordinates as a GRanges object with
a `frame' value.
}
\usage{
findCDS(fastaFile, startCodon = c("ATG"), stopCodon = c("TAG", "TAA", "TGA"))
}
\arguments{
  \item{fastaFile}{
    Fasta file of transcriptome sequences.
}
  \item{startCodon}{
    Vector of possible start codons. Defaults to "ATG". 
}
  \item{stopCodon}{
    Vector of possible stop codons. Defaults to c("TAG", "TAA", "TGA").
}
}

\value{
  A GRanges object.
}
\author{
  Thomas J. Hardcastle
}

\examples{
datadir <- system.file("extdata", package = "riboSeqR")
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))
}

\keyword{IO}
\keyword{manip}

\name{libScales}
\alias{libScales}
\title{
Generates library scaling factors from ribosome footprint (and
associated RNA) data.
}
\description{
This function applies the library scaling factor estimation methods
implemented in the baySeq package to ribosome footprint data and (if
present) the associated RNA-Seq data. The library scaling factors can
then be used in downstream analyses. 
}
\usage{
libScales(rC, riboDat, lengths, frames, method = "edgeR")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{rC}{
    A \code{\link{riboCoding}} object containing the coordinates of the
    coding sequences and the number of ribosomal footprint reads of
    various classes to be found in each.
  }
  \item{riboDat}{
    A \code{\link{riboData}} object containing the ribosome footprint
    and RNA-seq alignments.
  }
  \item{lengths}{
    Lengths of ribosome footprints to inform count data.
  }
  \item{frames}{
    Frames of ribosome footprints (relative to coding start site). If
    omitted, all frames are used. 
}
  \item{method}{
    Method to be used for scaling factor estimation. See \code{\link[baySeq]{getLibsizes}}
}
}
\value{
A list object containing
\item{riboLS}{Ribosome footprint library scaling factors.}
\item{rnaLS}{RNA-Seq library scaling factors.}
}
\author{
Thomas J. Hardcastle
}
\keyword{manip}

\name{sliceCounts}
\alias{sliceCounts}
\title{
Slices out count data from riboCoding object for use in differential
translation analyses.
}
\description{
For any given coding sequence, multiple lengths of reads in various
frames (relative to coding start) may align. This function extracts
specific size-classes and frames of ribosome footprint reads and sums
them to give a single value for each coding sequence and each sequencing
library, for use in downstream analysis.
}
\usage{
sliceCounts(rC, lengths = 27, frames)
}
\arguments{
  \item{rC}{
    A \code{\link{riboCoding}} object containing the coordinates of the
    coding sequences and the number of ribosomal footprint reads of
    various classes to be found in each.
}
  \item{lengths}{
    Lengths of ribosome footprints to inform count data.
}
  \item{frames}{
    Frames of ribosome footprints (relative to coding start site). If
    omitted, all frames are used. 
}
}
\details{
  Frames can be given as a single vector (which specifies the frames
  used for all lengths of footprints, or as a list, specifying the frame
  for each length given in `lengths'.

  The count data thus acquired can be compared to counts of RNA-seq data
  through a beta-binomial analysis (see vignette) to discover
  differential translation.
}
\value{
A matrix containing counts of ribosomal footprint matches to coding
sequences specified in riboCoding object `rC'.
}
\author{
Thomas J. Hardcastle
}

\seealso{
\code{\link{rnaCounts}}
}
\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M")) 

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)


# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = fCs, lengths = 27:28)

# filter coding sequences. 27-mers are principally in the 1-frame,
# 28-mers are principally in the 0-frame relative to coding start (see
# readingFrame function).

ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(1, 0), 
                   hitMean = 50, unqhitMean = 10, fS = fS)

# Extract counts of ribosomal footprints from riboCount data.

riboCounts <- sliceCounts(ffCs, lengths = c(27, 28), frames = list(0,
2))

}
\keyword{manip}

\name{riboData-class}
\docType{class}
\alias{riboData}
\alias{riboData-class}

\title{Class "riboData"}

\description{
  The \code{riboData} class contains a list of GRanges objects
  containing ribosome footprint alignment data, a factor defining the
  replicate structure of the samples involved, and (optionally) a list
  of GRanges objects containing RNA-seq alignment data (paired with the
  ribosome footprint data). It will generally be created by the
  `readRibodata' function and not directly by the user.
}

\section{Slots}{
  \describe{
    \item{\code{riboGR}:}{List of \code{"GRanges"} objects (one for each
      sequenced sample) describing the alignments of ribosomal footprint
      data to a transcriptome.}
    \item{\code{rnaGR}:}{List of \code{"GRanges"} objects (one for each
      sequenced sample, paired with `riboGR' slot) describing the
      alignments of RNA-seq data to a transcriptome.}
    \item{\code{replicates}:}{A factor defining the replicate structure
      of the samples for which data are held. Replicate samples will have
      the same level in this factor.}
    }
}

\section{Methods}{
  No methods are currently defined for this class.
}

\author{Thomas J. Hardcastle}

\keyword{classes}

\name{filterHits}
\alias{filterHits}
\title{
  Filters framecalled data based on the mean number of hits observed
  across a replicate group.
}
\description{
If no ribosomal footprints of the correct lengths (and frames) are seen
at a coding sequence in any replicate group, this sequence is unlikely
to be translated (and is therefore likely to be uninteresting). This
function filters out these coding sequences, leaving only those with a
minimum number of hits in at least one replicate group, and a minimum
number of unique sequences aligning in at least one replicate group (to
exclude single stacks of sequenced reads passing the filtering).
}
\usage{
filterHits(fCs, lengths = 27, frames, hitMean = 10, unqhitMean = 1,
ratioCheck = TRUE, fS)
}
\arguments{
  \item{fCs}{
    \code{riboCoding} object defining the number of ribosome footprint
    reads observed over a set of coordinates, their lengths, and their
    frame relative to coding start sites.
}
  \item{lengths}{
    The lengths of ribosome footprint reads to be used in filtering.
}
  \item{frames}{
    If given, the frames of the ribosome footprint reads to be used in
    filtering. Should be of equal length to the `lengths' parameter -
    see examples.
}
  \item{hitMean}{
    The mean number of hits within a replicate group that should be
    observed to pass filtering.
}
  \item{unqhitMean}{
    The mean number of unique sequences within a replicate group that
    should be observed to pass filtering. This parameter is intended to
    avoid cases where a coding sequence is deemed to be expressed based
    on a few highly expressed sequences.    
  }
  \item{ratioCheck}{
    Checks the ratios of expected phase to maximal phase within the
    putative coding sequence. See Details.
  }
  \item{fS}{
    The output of 'frameCounting' function. Required if 'ratioCheck = TRUE'.
  }
}
\details{
  Frames can be given as a single vector (which specifies the frames
  used for all lengths of footprints, or as a list, specifying the frame
  for each length given in `lengths'.

  For highly translated coding regions, the small proportion of
  out-of-phase reads may cause overlapping but out-of-phase putative
  coding regions to pass this filtering step. If 'ratioCheck = TRUE',
  filterHits identifies those cases where the phase with the maximum
  number of reads (the maximal phase) is not the expected phase for that
  putative coding region. If the ratio of reads in the expected phase to
  maximal phase does not significantly (Chi-squared test with
  significance threshold of 0.05) exceed that ratio observed for all
  coding regions, the putative coding region is filtered out.
}
\value{
  \code{riboCoding} object containing the filtered coding sequences and
  the associated numbers of ribosome footprint reads.
}
\author{
  Thomas J. Hardcastle
}

\seealso{
  \code{frameCounting}
}
\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M"))

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)

# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = fCs, lengths = 27:28)

# filter coding sequences. 27-mers are principally in the 1-frame,
# 28-mers are principally in the 0-frame relative to coding start (see
# readingFrame function).

ffCs <- filterHits(fCs, lengths = c(27, 28), frames = list(1, 0), 
                   hitMean = 50, unqhitMean = 10, fS = fS)


}
\keyword{manip}

\name{lengthDist}
\alias{lengthDist}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
A function plotting the density of lengths in a riboData object.
}
\description{
riboData object contain data on multiple lengths of sequenced
reads. This function plots the density of those lengths.
}
\usage{
lengthDist(riboDat, add = FALSE, legend = NULL, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{riboDat}{
    riboData object to be plotted
}
  \item{add}{
    Should the curve be added to an existing plot, or a new plot drawn?
}
  \item{legend}{
    Legend text, if given.
}
  \item{\dots}{
    Additional arguments to be passed to `plot' or `legend'.
}
}
\author{
Thomas J. Hardcastle
}

\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M"))

lengthDist(riboDat)
}

\keyword{plot}

\name{readingFrame}
\alias{readingFrame}
\alias{plotFS}
\title{
Analyses frame called ribosome footprint data within coding sequences
and identifies likely frame-shift of different length ribosome footprint reads.
}
\description{
Ribosome footprint data data can be used to identify the frame-shift
relative to start codon of the different n-mers. For each readlength
specified, the sum of alignments in the different frames is shown,
together with the maximum likelihood frame.
}
\usage{
readingFrame(rC, lengths = 26:30)
plotFS(fS, lengths, legend.text = c("Frame 0", "Frame 1", "Frame 2"), ...)
}
\arguments{
  \item{rC}{
    A riboCoding object, produced by the \code{\link{frameCounting}} function.
}
  \item{lengths}{
    Lengths of reads to be analysed for frame-shift, or to be
    plotted. May be omitted in plotting, in which case all lengths will
    be plotted.
  }
  \item{fS}{
    The output of the readingFrame function, to be plotted.}
  \item{legend.text}{
    Text for legend.
  }
  \item{...}{
    Additional arguments to be passed to barplot function.
    }
}
\value{
  A matrix giving the number of aligned reads in each frame for each
  length, and the maximum likelihood frame.
}

\author{
Thomas J. Hardcastle
}

\seealso{
\code{\link{frameCounting}}
}
\examples{
#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M"))

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
rCs <- frameCounting(riboDat, fastaCDS)

# analysis of frame shift for 27 and 28-mers.
fS <- readingFrame(rC = rCs, lengths = 27:28)
plotFS(fS)

}
\keyword{manip}

\name{readRibodata}
\alias{readRibodata}
\title{
  Reads ribosomal and (optionally) rna data from alignment files.
}
\description{
  Reads BAM files, or flat text files (which may be compressed)
  containing strand, transcript name, start and sequence information for
  each alignment.
}
\usage{
readRibodata(riboFiles, rnaFiles, columns = c(strand = 1, seqname = 2,
start = 3, sequence = 4), zeroIndexed = FALSE, header = FALSE, replicates, seqnames)
}
\arguments{
  \item{riboFiles}{
    Filenames of ribosomal alignments.
}
  \item{rnaFiles}{
    Filenames of RNA alignments.
}
  \item{columns}{
    Columns of alignment files containing strand, transcript (seqname)
    name, start of alignment, and sequence. Ignored for BAM files.
  }
  \item{zeroIndexed}{
    Are the alignments zero-indexed (i.e., the first base in a sequence
    is 0). Defaults to FALSE.}
  \item{header}{
    Does the (non-bam) alignment file have a header line? Defaults to FALSE.
}
  \item{replicates}{
    Replicate information for the files.
}
  \item{seqnames}{
    Transcript (seqname) names to be read into the object. 
}
}
\details{
If a filename ends in '.bam' or '.BAM' it will be assumed that the file is
a BAM file and processed accordingly. Otherwise, it will be treated as a
flat text file.

If using text files these should contain (as a minimum), the sequence of the read, the name of the sequence to which the read aligns, the strand to which it aligns, and the starting position of alignment. A Bowtie alignment (note that Bowtie, rather than Bowtie2, is recommended for short reads, which ribosome footprints are) using the option ``--suppress 1,6,7,8'' will generate this minimal data. It is by default assumed that the data are generated in this way, and the default columns specification for the default readRibodata function (see below) reflects this.
}
\value{
\code{riboData} object.
}
\author{
Thomas J. Hardcastle
}

\examples{
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT", "M", "M"))
}
\keyword{IO}
\keyword{manip }

\name{frameCounting}
\alias{frameCounting}

\title{
Counts aligned reads within coding sequence regions by frame and
footprint size, splitting by frame and footprint size.
}
\description{
Ribosome footprint sequencing reads aligning within coding sequence
regions may align in the same frame (relative to start codon) as the
coding sequence, or frame shifted by 1 or 2 frames. This function calls
the number of aligning reads within the coding sequence, split by frame
and footprint size.
}
\usage{
frameCounting(riboDat, cds, lengths = 25:30, offset5p = 0, offset3p = 0)
}
\arguments{
  \item{riboDat}{
    A \code{riboData} object containing the ribosome footprints to be counted. 
}
  \item{cds}{
    A \code{GenomicRanges} object containing the coordinates of the
    coding sequences.
  }
  \item{lengths}{
    Lengths of ribosome footprints to be included in the \code{riboData} object.
  }
  \item{offset5p}{
    An offset to the 5' end of the coding sequence coordinates to
    include ribosome footprints some distance upstream of coding start.}
  \item{offset3p}{
    An offset to the 3' end of the coding sequence coordinates to exclude
    reads too close to coding stop.}
}
\value{
  A \code{riboCoding} object.
}
\author{
Thomas J. Hardcastle
}

\seealso{
  \code{riboData}
}
\examples{

#ribosomal footprint data
datadir <- system.file("extdata", package = "riboSeqR")
ribofiles <- paste(datadir, 
                   "/chlamy236_plus_deNovo_plusOnly_Index", c(17,3,5,7), sep = "")
rnafiles <- paste(datadir, 
                  "/chlamy236_plus_deNovo_plusOnly_Index", c(10,12,14,16), sep = "")

riboDat <- readRibodata(ribofiles, rnafiles, replicates = c("WT", "WT",
"M", "M"))

# CDS coordinates
chlamyFasta <- paste(datadir, "/rsem_chlamy236_deNovo.transcripts.fa", sep = "")
fastaCDS <- findCDS(fastaFile = chlamyFasta, 
                    startCodon = c("ATG"), 
                    stopCodon = c("TAG", "TAA", "TGA"))

# frame calling
fCs <- frameCounting(riboDat, fastaCDS)


}
\keyword{manip}

\name{riboSeqR-package}
\alias{riboSeqR-package}
\alias{riboSeqR}
\docType{package}
\title{
Analysis of sequencing data from ribosome profiling experiments.
}
\description{
Plotting functions, frameshift detection and parsing of sequencing
    data from ribosome profiling experiments.
}
\details{
\tabular{ll}{
Package: \tab riboSeqR\cr
Type: \tab Package\cr
Version: \tab 1.0.0\cr
Date: \tab 2014-05-02\cr
License: \tab GPL-3\cr
LazyLoad: \tab yes\cr
Depends: \tab R (>= 3.0.2), methods, baySeq, GenomicRanges, abind\cr
Imports: \tab GenomicRanges, methods, abind\cr
Packaged: \tab 2014-05-16 10:49:24 UTC; tjh48\cr
Built: \tab R 3.0.2; ; 2014-05-16 10:49:44 UTC; unix\cr
}

Further information is available in the following vignettes:
\tabular{ll}{
\code{riboSeqR} \tab riboSeqR (source, pdf)\cr
}
}

\author{
Thomas J. Hardcastle

Maintainer: Thomas J. Hardcastle <tjh48@cam.ac.uk>
}

\keyword{ package }
